# -*- coding: utf-8 -*-
"""
Created on Mon May 21 13:50 2018
Modified on Thu May 30 12:02 2019
@author: katayan
"""

# Pythonの基礎

# 1) コメント

# コメント行です

123 # 行の途中からでもコメントを書けます


# 2) Pythonの主要データ型
# (1) 文字列

'メッシュ農業気象データ'

"メッシュ農業気象データ"

'"メッシュ"農業気象データ'

"That's a good idea."


'メッシュ
農業気象データ'

'''
メッシュ
農業気象
データ
'''

# (2)数値

1

1.


# 3) 四則演算と代入文

"メッシュ" + "農業" + "気象"

"実習" + 1

"実習" + "1" # "実習" + str(1) でも可


# 【練習問題】

1 + 2

1.0 + 2

2 - 1

2.0 - 1

2 * 2

2 * 2.0

6 / 3

7 / 3

7 // 3

7 % 3

"メッシュ" + "農業" + "気象"

"農業" * 3

"農業" + 5

"農業" + "5"


# 4) 変数と代入文

a = 100
a = a + 10
a


# 5) 累積代入文 

a = 100
a += 10
a

a = 100
a -= 10
a

a = 100
a *= 10
a

a = 100
a /= 10
a


# 6) 比較演算子

a, b, c = 100, 200, 50
a < b > c  

# 7) Pythonで使われる特徴的なデータ

# (1) リスト

lis1 = [1, 2, 3]
lis2 = [4, 5]
lis1 + lis2

lis = [1, 2, 3]
lis += [4, 5]
lis

lis = ["零", "一", "二", "三", "四"]
lis[1]

lis = ["零", "一", "二", "三", "四", "五", "六", "七"]
lis[1:6]

# 練習問題
lis[:]
lis[3:]
lis[:4]
lis[-5:-3]
lis[-2:]
lis[:-3]

mixed = [10, 20, "Mesh", [100, 200, 300]]
mixed[3][1]

lis = [1, 2, 3]
lis[0] = 'メッシュ'
lis

lis[1:3] = ['農業', '気象']
lis

# 表4
lis = [1, 2, 3]
lis.append("あとはたくさん")
lis

lis = [10, 20, 30, 40]
lis.insert(2, 100)
lis


lis = ["a", "b", "c", "d"]
lis.pop(2)
lis

lis = ["a", "b", "c", "d"]
lis.index("d")

lis = [10, 1, 7, 2]
lis.sort()

lis = [1, 2, 3, 4]
lis.reverse()

# (2) タプル

tsukuba = (36.0270, 140.1104)
tsukuba.append(150.3)


# (3) 辞書
station = ["Tsukuba", 36.0270, 140.1104]
station[0]

station = {"name":"Tsukuba", 
           "lat":36.0270, 
           "lon":140.1104,
           "asl":-999.9}
station

station["name"]

station["asl"] = 11.3 
station["asl"]


station.values()

station.keys()


# 制御構文 for

for i in [0, 1, 2]:
    print(i)

for i in [0, 1, 2]:
    print(i)
print(i, "までで終了")


for i in range(3):
    print(i)
print(i, "までで終了")

# 練習問題
for i in range(1, 5):
    print(i)
print(i,"までで終了")

for i in range(1, 10, 2):
    print(i)
print(i,"までで終了")
 
# 2) リスト内包表記

[i*5+1 for i in range(5)]

x = []
for i in range(5):
    x.append(i * 5 + 1)
x


# 3) if, elif, else による条件分岐

value = 10
if value <= 3:
    print(vaｌue, "じゃすくないな。")

elif 3 < value <= 5:
    print(vaｌue, "だしまあまあか。")

else:
    print(vaｌue, "だなんてラッキー。")


# 4) break文とcontinue文について
    
for i in range(10):
   if i == 3:
       break

   print(i)
    
for i in range(10):
    if i == 3:
        continue

    print(i)
 

# Pythonの関数
    
def calc_add(a, b):
    c = a + b
    return c

def calc_addif(a, b):
    c = a + b
    d = a - b
    return c, d

def calc_add_tax(a, b, tax=0.08):
    c = a + b
    c += c * tax
    return c

calc_add_tax(100, 200)  # デフォルト税率の8％を採用する場合

calc_add_tax(100, 200, tax=0.05)  # 税率5％を採用する場合


# モジュール（ライブラリ・パッケージ）とインポート

import AMD_Tools3　as　AMD

from math import floor

floor(3.14)


# 数値計算ライブラリーNumPy
# 1) 多次元数値配列 ndarry    

import numpy as np

data = [1, 2, 3]
npdata = np.array(data)
npdata

npdata + npdata

npdata - npdata

npdata * npdata

npdata / npdata

npdata + 10

npdata - 10

npdata * 10

npdata / 10

npdata /10 * data

# 練習問題
data + data

data - data

data * data

data / data

data + 10

data - 10

data * 10

data / 10

data /10 * data


# 2) 3次元ndarrayの添え字


arr = np.zeros((3, 4, 5))
arr

arr = np.arange(60.0).reshape(3, 4, 5)
arr

arr[0, 1, 2]

arr[2, :, :]

arr[:, 2, 3]

arr[0, 1, 2] = np.nan
arr

np.isnan(arr)

~np.isnan(arr)

len(arr)

len(arr[0])

arr.shape


